import spread_core.mqtt as mqtt
from spread_core.bam.managers import Manager
from spread_core.errors.project_errors import InitError
from spread_core.tools import settings


class Mercury(Manager):
    INTERRUPT_SURVEY = False

    def __init__(self, p_id, m_id):
        super(Mercury, self).__init__(p_id, m_id)
        self.send_topic = None
        self.dump_topic = None

    def parse(self, data):
        super(Mercury, self).parse(data)

        if self.send_interface:
            self.send_interface.set_bus_params(self.bus)

    def add_provider(self, data, manager):
        super(Mercury, self).add_provider(data, manager)
        provider = self._providers[data['id']]
        if provider.address not in self._addresses:
            self._addresses[provider.address] = []
            if provider.address in settings.config.get(settings.HEXED, []):
                if self.send_interface:
                    self.send_interface.set_hexed(provider.address, True)
        self._addresses[provider.address].append(provider.id)
