from django.views.generic import TemplateView

from spread_core.bam.dali.providers import lights
from ..project import bam
from ..responses import Success


class DaliDimmer(TemplateView):
    template_name = 'dali/dimmer.html'

    def get(self, request, *args, **kwargs):
        provider_id = kwargs.get('id')
        if request.GET:
            return Success(True)
        return self.render_to_response(dict(
            providers=bam.models.Provider.objects.filter(type__in=[lights.DaliDimmer.__name__, lights.DaliTunableWhite, lights.DaliRelay]),
            config=bam.config(bam.models.Provider.objects.get(id=provider_id, type__in=[lights.DaliDimmer.__name__, lights.DaliTunableWhite, lights.DaliRelay])),
            fade_times={variant: int(variant.split('ft')[1]) / 10 for variant in lights.FadeTime.index_of},
            fade_rates={variant: int(variant.split('fr')[1]) / 10 for variant in lights.FadeRate.index_of},
            scene_ids=list(range(0, 16)),
            group_ids=[list(range(4*i, 4*i+4)) for i in range(0, 4)],
            curves=lights.DimmingCurve.index_of,
        ))
