from django.core.management.base import BaseCommand

from spread_dashboard.project.bam import Project
from spread_dashboard.scheduler.models import SchBase, Holiday
from spread_dashboard.incubator import models as incubator


class Command(BaseCommand):
    help = 'Updates database from local files'

    def add_arguments(self, parser):
        parser.add_argument('--all', action='store_true', help='Does need fill project data')
        parser.add_argument('-c', '--ctp', action='store_true', help='Does need fill project data')
        parser.add_argument('-t', '--tasks', action='store_true', help='Does need fill schedulers dump')
        parser.add_argument('-cal', '--calendar', action='store_true', help='Does need fill calendar dump')
        parser.add_argument('-cy', '--cycles', action='store_true', help='Does need fill incubator dump')

    def handle(self, *args, **options):
        if options.get('ctp') or options.get('all'):
            Project.read_ctp()

        if options.get('calendar') or options.get('all'):
            Holiday.fill()

        if options.get('tasks') or options.get('all'):
            SchBase.fill()

        if options.get('cycles') or options.get('all'):
            incubator._IncBase.fill()
