var timers = {};

$(document).ready(function (e) {
    getTriggers($("select[name=day]")[0].selectedIndex);
    $(document).find('.cycle label').each(function (i, label) {
        label.textContent = label.textContent.replace(':', '');
    })
});

function addTrigger(form) {
    const day = $("select[name=day]")[0].selectedIndex;
    $.get(form.action, {day: day}).done(function (data) {
        const q = $(form).parent(' td').find('.triggers').append(data);
        q[0].lastElementChild.day.value = day;
    })
}

function setTrigger(form, data) {
    setTimer(arguments.callee.name +'_'+ form.id.value, form, function (data) {
        form.innerHTML = data;
        const time = form.time.value.split(':');
        if (!triggers.hasOwnProperty(form.id.value)) {
            triggers[form.id.value] = [parseInt($("select[name=day]")[0].value), 0, 0];
        }
        triggers[form.id.value][1] = parseInt(time[0])*60+parseInt(time[1]);
        triggers[form.id.value][2] = parseInt(form.level.value);
        drawGraph();
    });
    return false;
}

function removeTrigger(form) {
    if (form.id.value) {
        $.post(form.action, form2data(form, {remove: true}));
        delete triggers[parseInt(form.id.value)];
        drawGraph();
    }

    form.remove();
}

function getTriggers(day) {
    $.get(document.location.pathname + 'triggers/', {day: day}).done(updateTriggers);
}

function copyTriggers() {
    $.get('copy/', {
        template: $(document).find('#day-to-copy select')[0].value,
        day: $('select[name=day]')[0].value
    }).done(updateTriggers);
}

function updateTriggers(data) {
    data = JSON.parse(data);
    $('.triggers form').remove();
    $('.triggers').append(data.triggers);

    function updateSelector(i, selector) {
        selector.options.length = data.count;
        $(selector).find(' option').each(function(i, opt) {
            opt.value = i;
            opt.textContent = 'День ' + (i+1);
        });
    }
    $("select[name=day]").each(updateSelector);
    $("#day-to-copy select").each(function (i, selector) {
        updateSelector(i, selector);
        selector.options[$("select[name=day]")[0].selectedIndex].remove();
    });

    drawGraph();
}

function onNavi(direction) {
    const selector = $("select[name=day]")[0];
    if (selector.options.length > selector.selectedIndex + direction && selector.selectedIndex + direction >= 0) {
        selector.selectedIndex += direction;
        selector.onchange(selector);
    }
}

function form2data(form, formData) {
    formData = formData ? formData : {};
    $(form).find("input[name]").each(function (index, node) {
        if (node.type === 'checkbox') {
            formData[node.name] = node.checked;
        } else {
            formData[node.name] = node. value;
        }
    });
    $(form).find("select[name]").each(function (index, node) {
        formData[node.name] = node.value;
    });

    return formData;
}

function setTimer(id, form, callback) {
    clearTimeout(timers[id]);

    if (form.checkValidity()) {
        timers[id] = setTimeout(function () {
            $.post(form.action, form2data(form)).done(function (data) {
                if (callback) {
                    callback(data);
                }
            });
        }, 500);
    }
}

// [номер дня, время триггера в минутах от 0:00 текущего дня, значение яркости]
// Должно быть отсортировано по дню + времени
function drawGraph() {
    const form = $('.cycle form')[0];
    const startBrightness = parseInt(form.startLevel.value);
    const fadeTime = parseInt(form.duration.value);
    const numberOfDays = parseInt(form.period.value);
    const currentDay = parseInt($("select[name=day]")[0].value);
    const data = Object.values(triggers).sort(function (a, b) {
        if (a[0] === b[0]) return (a[1] > b[1]) ? 1 : ( (b[1] > a[1]) ? -1 : 0 );
        return (a[0] > b[0]) ? 1 : ( (b[0] > a[0]) ? -1 : 0 )
    });

    DrawCycleGraph(document.getElementById('graphCanvasCycle'),
        data,
        startBrightness,
        fadeTime,
        'Весь цикл ',
        'Дни',
        numberOfDays,
        currentDay,
        null
    );
    DrawDayGraph(
        document.getElementById('graphCanvasDay'),
        data,
        startBrightness,
        fadeTime,
        'День ' + (currentDay+1),
        'Часы',
        numberOfDays,
        currentDay,
        null
    );
}