import json
import logging
import os

from django.db import models


def serialize(self) -> dict:
    assert isinstance(self, models.Model)

    def to_json(val):
        if isinstance(val, (int, str, list, tuple, dict)) or val is None:
            return val
        return str(val)

    return {
        'id': self.id,
        **{
            field.attname: to_json(getattr(self, field.attname))
            for field in self._meta.fields if field.serialize
        }
    }


def write_file(file, data):
    os.makedirs(os.path.dirname(file), exist_ok=True)
    with open(file, 'w') as fs:
        fs.write(json.dumps(data, indent=2))
        logging.info('update %s' % file)
